from greg.api.serializers.invitation import InvitationSerializer
from greg.models import InvitationLink, Sponsor
from gregui.mailutils.invite_guest import InviteGuest
from rest_framework import permissions, status, viewsets
from rest_framework.response import Response


class InvitationViewSet(viewsets.ModelViewSet):
    """Invitation API"""

    serializer_class = InvitationSerializer
    permission_classes = (permissions.IsAdminUser,)

    def create(self, request, *args, **kwargs):
        serializer = self.get_serializer(data=request.data)
        serializer.is_valid(raise_exception=True)

        person = serializer.save()

        sponsor_feide_id = serializer.validated_data["sponsor"]
        sponsor = Sponsor.objects.get(feide_id=sponsor_feide_id)

        for invitationlink in InvitationLink.objects.filter(
            invitation__role__person_id=person.id,
            invitation__role__sponsor_id=sponsor.id,
        ):
            invitemailer = InviteGuest()
            invitemailer.queue_mail(invitationlink)

        headers = self.get_success_headers(serializer.validated_data)
        return Response(status=status.HTTP_201_CREATED, headers=headers)
